org.apache.lucene.spatial3d.geom

## Class GeoDegenerateVerticalLine

- java.lang.Object
- - org.apache.lucene.spatial3d.geom.BasePlanetObject
  - - org.apache.lucene.spatial3d.geom.GeoBaseShape
    - - org.apache.lucene.spatial3d.geom.GeoBaseMembershipShape
      - - org.apache.lucene.spatial3d.geom.GeoDegenerateVerticalLine

- All Implemented Interfaces:
    GeoArea, GeoBBox, GeoMembershipShape, GeoOutsideDistance, GeoShape, GeoSizeable, Membership

      public class GeoDegenerateVerticalLine
      extends GeoBaseMembershipShape

  Degenerate bounding box limited on two sides (top lat, bottom lat).
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static int` | `ALL_INSIDE` All edgepoints inside shape
    `protected double` | `bottomLat` Bottom latitude of the vertical line
    `protected SidedPlane` | `bottomPlane` Bottom end cutoff plane
    `protected SidedPlane` | `boundingPlane` Back-side cutoff plane
    `protected GeoPoint` | `centerPoint` A computed center point for the line
    `protected GeoPoint[]` | `edgePoints` A point that's on the line
    `protected GeoPoint` | `LHC` Point at the lower end of the vertical line
    `protected double` | `longitude` Longitude of the vertical line
    `protected static int` | `NONE_INSIDE` No edgepoints inside shape
    `protected Plane` | `plane` The vertical line plane
    `protected GeoPoint[]` | `planePoints` Notable points for the line (end points)
    `protected static int` | `SOME_INSIDE` Some edgepoints inside shape
    `protected double` | `topLat` Top latitude of the vertical line
    `protected SidedPlane` | `topPlane` Top end cutoff plane
    `protected GeoPoint` | `UHC` Point at the upper end of the vertical line

    - ### Fields inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

      `planetModel`

    - ### Fields inherited from interface org.apache.lucene.spatial3d.geom.GeoArea

      `CONTAINS, DISJOINT, OVERLAPS, WITHIN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeoDegenerateVerticalLine(PlanetModel planetModel, double topLat, double bottomLat, double longitude)` Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, longitude: `-PI -> PI`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object o)`
    `GeoBBox` | `expand(double angle)` Expand box by specified angle.
    `void` | `getBounds(Bounds bounds)` Compute bounds for the shape.
    `GeoPoint` | `getCenter()` Returns the center of a circle into which the area will be inscribed.
    `GeoPoint[]` | `getEdgePoints()` Return a sample point that is on the outside edge/boundary of the shape.
    `double` | `getRadius()` Returns the radius of a circle into which the GeoSizeable area can be inscribed.
    `int` | `getRelationship(GeoShape path)` Find the spatial relationship between a shape and the current geo area.
    `int` | `hashCode()`
    `boolean` | `intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)` Assess whether a plane, within the provided bounds, intersects with the shape.
    `protected int` | `isShapeInsideBBox(GeoShape path)` Determine the relationship between this BBox and the provided shape's edgepoints.
    `boolean` | `isWithin(double x, double y, double z)` Check if a point is within this shape.
    `protected double` | `outsideDistance(DistanceStyle distanceStyle, double x, double y, double z)` Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.spatial3d.geom.GeoBaseMembershipShape

      `computeOutsideDistance, computeOutsideDistance, isWithin`

    - ### Methods inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

      `getPlanetModel`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoOutsideDistance

      `computeOutsideDistance, computeOutsideDistance`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Membership

      `isWithin`

- - ### Field Detail

    - #### topLat

          protected final double topLat

      Top latitude of the vertical line

    - #### bottomLat

          protected final double bottomLat

      Bottom latitude of the vertical line

    - #### longitude

          protected final double longitude

      Longitude of the vertical line

    - #### UHC

          protected final GeoPoint UHC

      Point at the upper end of the vertical line

    - #### LHC

          protected final GeoPoint LHC

      Point at the lower end of the vertical line

    - #### topPlane

          protected final SidedPlane topPlane

      Top end cutoff plane

    - #### bottomPlane

          protected final SidedPlane bottomPlane

      Bottom end cutoff plane

    - #### boundingPlane

          protected final SidedPlane boundingPlane

      Back-side cutoff plane

    - #### plane

          protected final Plane plane

      The vertical line plane

    - #### planePoints

          protected final GeoPoint[] planePoints

      Notable points for the line (end points)

    - #### centerPoint

          protected final GeoPoint centerPoint

      A computed center point for the line

    - #### edgePoints

          protected final GeoPoint[] edgePoints

      A point that's on the line

    - #### ALL_INSIDE

          protected static final int ALL_INSIDE

      All edgepoints inside shape
      See Also:
        Constant Field Values

    - #### SOME_INSIDE

          protected static final int SOME_INSIDE

      Some edgepoints inside shape
      See Also:
        Constant Field Values

    - #### NONE_INSIDE

          protected static final int NONE_INSIDE

      No edgepoints inside shape
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### GeoDegenerateVerticalLine

          public GeoDegenerateVerticalLine(PlanetModel planetModel,
                                           double topLat,
                                           double bottomLat,
                                           double longitude)

      Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, longitude: `-PI -> PI`

  - ### Method Detail

    - #### expand

          public GeoBBox expand(double angle)

      Description copied from interface: `GeoBBox`
      Expand box by specified angle.
      Parameters:
        `angle` - is the angle amount to expand the GeoBBox by.
      Returns:
        a new GeoBBox.

    - #### isWithin

          public boolean isWithin(double x,
                                  double y,
                                  double z)

      Description copied from interface: `Membership`
      Check if a point is within this shape.
      Parameters:
        `x` - is x coordinate of point to check.
        `y` - is y coordinate of point to check.
        `z` - is z coordinate of point to check.
      Returns:
        true if the point is within this shape

    - #### getRadius

          public double getRadius()

      Description copied from interface: `GeoSizeable`
      Returns the radius of a circle into which the GeoSizeable area can be inscribed.
      Returns:
        the radius.

    - #### getCenter

          public GeoPoint getCenter()

      Description copied from interface: `GeoSizeable`
      Returns the center of a circle into which the area will be inscribed.
      Returns:
        the center.

    - #### getEdgePoints

          public GeoPoint[] getEdgePoints()

      Description copied from interface: `GeoShape`
      Return a sample point that is on the outside edge/boundary of the shape.
      Returns:
        samples of all edge points from distinct edge sections. Typically one point is returned, but zero or two are also possible.

    - #### intersects

          public boolean intersects(Plane p,
                                    GeoPoint[] notablePoints,
                                    Membership... bounds)

      Description copied from interface: `GeoShape`
      Assess whether a plane, within the provided bounds, intersects with the shape. Note well that this method is allowed to return "true" if there are internal edges of a composite shape which intersect the plane. Doing this can cause getRelationship() for most GeoBBox shapes to return OVERLAPS rather than the more correct CONTAINS, but that cannot be helped for some complex shapes that are built out of overlapping parts.
      Parameters:
        `p` - is the plane to assess for intersection with the shape's edges or bounding curves.
        `notablePoints` - represents the intersections of the plane with the supplied bounds. These are used to disambiguate when two planes are identical and it needs to be determined whether any points exist that fulfill all the bounds.
        `bounds` - are a set of bounds that define an area that an intersection must be within in order to qualify (provided by a GeoArea).
      Returns:
        true if there's such an intersection, false if not.

    - #### getBounds

          public void getBounds(Bounds bounds)

      Description copied from interface: `GeoShape`
      Compute bounds for the shape.
      Specified by:
        `getBounds` in interface `GeoShape`
      Overrides:
        `getBounds` in class `GeoBaseShape`
      Parameters:
        `bounds` - is the input bounds object. The input object will be modified.

    - #### getRelationship

          public int getRelationship(GeoShape path)

      Description copied from interface: `GeoArea`
      Find the spatial relationship between a shape and the current geo area. Note: return value is how the GeoShape relates to the GeoArea, not the other way around. For example, if this GeoArea is entirely within the shape, then CONTAINS should be returned. If the shape is entirely enclosed by this GeoArea, then WITHIN should be returned. It is permissible to return OVERLAPS instead of WITHIN if the shape intersects with the area at even a single point. So, a circle inscribed in a rectangle could return either OVERLAPS or WITHIN, depending on implementation. It is not permissible to return CONTAINS or DISJOINT in this circumstance, however. Similarly, it is permissible to return OVERLAPS instead of CONTAINS under conditions where the shape consists of multiple independent overlapping subshapes, and the area overlaps one of the subshapes. It is not permissible to return WITHIN or DISJOINT in this circumstance, however.
      Parameters:
        `path` - is the shape to consider.
      Returns:
        the relationship, from the perspective of the shape.

    - #### outsideDistance

          protected double outsideDistance(DistanceStyle distanceStyle,
                                           double x,
                                           double y,
                                           double z)

      Description copied from class: `GeoBaseMembershipShape`
      Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
      Specified by:
        `outsideDistance` in class `GeoBaseMembershipShape`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `BasePlanetObject`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `BasePlanetObject`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### isShapeInsideBBox

          protected int isShapeInsideBBox(GeoShape path)

      Determine the relationship between this BBox and the provided shape's edgepoints.
      Parameters:
        `path` - is the shape.
      Returns:
        the relationship.

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.